<?php
require_once dirname(__FILE__).'/../../libs/facebook/facebook.php';

class FacebookSocialComponent extends AbstractSocialComponent
{
    private $_facebook;
    private $_accessToken;
    public  $emailDomain = 'facebook.com';
    
    public function onInit()
    {
        $config = array(
          'appId'  => $this->getOption('appId'),
          'secret' => $this->getOption('appSecret'),
        );
        
        $this->_facebook = new Facebook($config);
    } // end onInit

    public function getName()
    {
        return 'facebook';
    } // end getName
    
    public function getUserData($token)
    {
        $this->_facebook->setAccessToken($token);
        
        $user = $this->_facebook->api('/me');
        
        if (!$user) {
            $message = "The user is not logged in the".$this->getName();
            $message .= " social network.";
            throw new Exception($message);
        }
        
        $data = array(
            'id' => $user['id']
        );

        if (isset($user['email'])) {
             $data['email'] = $user['email'];
        }

        return $data;
    } // end getUserData
}