<?php

require_once dirname(__FILE__).'/../../libs/twitter/FestiTwitterApp.php';

class TwitterSocialComponent extends AbstractSocialComponent
{
    private $_twitter;
    public  $emailDomain = 'twitter.com';
    
    public function onInit()
    {
        $config = array(
          'appId'  => $this->getOption('appId'),
          'secret' => $this->getOption('appSecret'),
        );

        $this->_twitter = new FestiTwitterApp(
            $config['appId'],
            $config['secret'],
            $this->getCallbackUrl()
        );
    } // end onInit
    
    protected function getCallbackUrl()
    {
		$url= $this->getAuthPageUrl();

		$currentUrl = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
		$data = parse_url($currentUrl);
		$query = (isset($data['query'])) ? '?'.$data['query'] : '';

		$pageUrl = $url.$query;

        return $pageUrl;
    } // end getCallbackUrl
    
    private function _isExistsTwitterAuthPage()
	{
		return get_option('twitterAuthPage');
	} // end _isExistsTwitterAuthPage

    public function getName()
    {
        return 'twitter';
    }
    
    public function getAuthUrl()
    {
        return $this->_twitter->getAuthUrl();
    } // end getAuthUrl
    
    public function getAccessToken()
    {
        return $this->_twitter->getToken();
    } // end getAuthUrl
    
    public function getUserInfo($token)
    {
        $oauth_token = $token['oauth_token'];
        $oauth_token_secret = $token['oauth_token_secret'];
        $screen_name = $token['screen_name'];
        
        return $this->_twitter->getUserData($oauth_token, $oauth_token_secret, $screen_name);
    } // end getUserInfo
    
    public function getUserData($token)
    {
        $user = $this->getUserInfo($token);
        
        if (!$user) {
            $message = "The user is not logged in the".$this->getName();
            $message .= " social network.";
            throw new Exception($message);
        }
        
        $data = array(
            'id' => $user['id']
        );

        if (isset($user['email'])) {
             $data['email'] = $user['email'];
        }

        return $data;
    } // end getUserData
}