<?php
require_once dirname(__FILE__).'/../../libs/vk/VK.php';
require_once dirname(__FILE__).'/../../libs/vk/VKException.php';

class VkSocialComponent extends AbstractSocialComponent
{
    private $_vk;
    
    public $emailDomain = 'vk.com';
    
    public function getName()
    {
        return 'vk';
    } // end getName
    
    public function onInit()
    {
        $this->_onInitVk();
    } // end onInit
    
    private function _onInitVk($token = null)
    {
        $config = array(
          'appId'  => $this->getOption('appId'),
          'secret' => $this->getOption('appSecret'),
        );
        
        $this->_vk = new VK\VK($config['appId'], $config['secret'], $token);
    } // end _onInitVk
    
    public function getUserData($token)
    {
        $args = array(
            'access_token' => $token,
            'fields' => 'id, email'
        );
        
        $user = $this->_vk->api('users.get', $args);
        
        if (!$user) {
            $message = "The user is not logged in the".$this->getName();
            $message .= " social network.";
            throw new Exception($message);
        }
        
        $data = array(
            'id' => $user['response'][0]['uid']
        );

        if (isset($user['response'][0]['email'])) {
             $data['email'] = $user['response'][0]['email'];
        }

        return $data;
    } // end getUserData
}